<?php

# As a general rule, if you as a programmer need to encrypt data of variable length 
# that you can't control, use padding with CBC mode. To avoid any ambiguity, make 
# it standard practice always to add padding. 
#
# If you use CFB or OFB modes of encryption, or use a stream cipher like RC4 or PC1, 
# then you don't use padding.

error_reporting(E_ALL);

define('AES_MAGIC',      	'AES');
define('AES_HEADER_LEN', 	12);
define('AES_BLOCK_LEN', 	16); # AES: nur 128 bit = 16 byte! (anders als bei Rijndael !)

if (!function_exists('file_put_contents')){
	function file_put_contents($file, $string) {
	  $f=fopen($file, 'w');
	  fwrite($f, $string);
	  fclose($f);
	}
}

# STRING #######################
function aes_encrypt_string($content, $key, $aes=128, $mode='cbc', $add_header=false)
{
	#global $crypt_modes;
	$crypt_modes = array('cbc', 'cfb', 'ofb', 'ecb', 'ctr');
	
	srand((double) microtime() * 1000000); //for sake of MCRYPT_RAND
	
  $rijndael = 'rijndael-'.$aes;
	$cp = mcrypt_module_open($rijndael, '', $mode, ''); #cbc, cfb und ofb
	if (strtoupper(substr(PHP_OS, 0, 3)) === 'WIN')
		$iv = mcrypt_create_iv(mcrypt_enc_get_iv_size($cp), MCRYPT_RAND);
	else
		$iv = mcrypt_create_iv(mcrypt_enc_get_iv_size($cp), MCRYPT_DEV_RANDOM);
		
  #$ks = mcrypt_enc_get_key_size($cp);
  #$key = substr(md5($key), 0, $ks);
  
  $encrypted = '';
  
  # add header
  if ($add_header){
  	$pad_len = ($ks-(strlen($content) % AES_BLOCK_LEN)) % AES_BLOCK_LEN;
  	$mode_num = array_search($mode, $crypt_modes);
  	$encrypted .= 'AES' . chr($aes/8) . chr($mode_num) . chr($pad_len) . "\x00\x00\x00\x00\x00\x00";
  }
  
  mcrypt_generic_init($cp, $key, $iv);
  $encrypted .= $iv . mcrypt_generic($cp, $content);
  mcrypt_generic_deinit($cp);
  mcrypt_module_close($cp);
  return $encrypted;
}

function aes_decrypt_string($content, $key, $aes=128, $mode='cbc')
{
	#global $crypt_modes;
	$crypt_modes = array('cbc', 'cfb', 'ofb', 'ecb', 'ctr');
	
 	$data_start = 0;
 	$pad_len = 0;
 	
 	# parse header
 	if (substr($content, 0, 3)==AES_MAGIC){
 		$aes  = ord($content{3})*8;
 		$mode_num = ord($content{4});
 		$mode = $crypt_modes[$mode_num];

 		#tmp
 		$pad_len = ord($content{5});
 		$data_start = AES_HEADER_LEN;
 	}
 	
 	$rijndael = 'rijndael-'.$aes;
 	
	$cp = mcrypt_module_open($rijndael, '', $mode, ''); #cbc, cfb und ofb
	$iv_size = mcrypt_enc_get_iv_size($cp);
		
	$iv = substr($content, $data_start, $iv_size);
	$content = substr($content, $data_start+$iv_size);
	
  #$ks = mcrypt_enc_get_key_size($cp);
  #$key = substr(md5($key), 0, $ks);
  
  mcrypt_generic_init($cp, $key, $iv);
  $decrypted = mdecrypt_generic($cp, $content);
  mcrypt_generic_deinit($cp);
  mcrypt_module_close($cp);
  
  if ($pad_len>0)
  	$decrypted = substr($decrypted, 0, -$pad_len);
  	
  return $decrypted;
  #return rtrim($decrypted);
}

# FILE #######################
function aes_encrypt_file($in_file, $out_file, $key, $aes=128)
{
	$str = file_get_contents($in_file);
	$str = aes_encrypt_string($str, $key, $aes);
	return file_put_contents($out_file, $str);
}

function aes_decrypt_file($in_file, $out_file, $key, $aes=128)
{
	$str = file_get_contents($in_file);
	$str = aes_decrypt_string($str, $key, $aes);
	return file_put_contents($out_file, $str);
}

?>